use std::future::Future;
use std::pin::Pin;

use http_body_util::Full;
use hyper::Response;
use hyper::{service::Service, Request};
use hyper::body::{Bytes, Incoming as IncomingBody};

#[derive(Debug, Clone, Copy)]
pub struct SniWebsitesService {
    
}

impl SniWebsitesService {
    fn make_body<T: Into<Bytes>>(res: T) -> Full<Bytes> {
        Full::new(res.into())
    }
}

impl Service<Request<IncomingBody>> for SniWebsitesService {
    type Response = Response<Full<Bytes>>;
    type Error = hyper::Error;
    type Future = Pin<Box<dyn Future<Output = Result<Self::Response, Self::Error>> + Send>>;

    fn call(&self, _req: Request<IncomingBody>) -> Self::Future {

        let res = Response::builder()
            .header("Server", "blek! CC 1.0")
            .body(Self::make_body("miau"))
            .unwrap();

        Box::pin(async { Ok(res) })
    }
}